/*
 * This file is a part of PikoTools
 * and is distributed under the (new) BSD licence.
 * Author: Tomasz Sowa <t.sowa@ttmath.org>
 */

/*
 * Copyright (c) 2021, Tomasz Sowa
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 *  * Neither the name Tomasz Sowa nor the names of contributors to this
 *    project may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "test.h"



namespace pt
{


void reset_test_counter()
{
	test_counter = 1;
	test_msg = nullptr;
}


void reset_test_counter(const char * msg)
{
	test_counter = 1;
	test_msg = msg;
}


void test_status(bool status)
{
	if( status )
	{
		std::cout << " OK";
	}
	else
	{
		std::cout << " Fail";
		was_error = true;
	}

	std::cout << std::endl;
}


template<>
bool test<const char*>(const char * test_msg, const char * provided, const char * expected)
{
	std::cout << "test " << test_counter << ": ";

	if( test_msg )
		std::cout << test_msg;

	bool status = (std::strcmp(provided, expected) == 0);
	test_status(status);
	test_counter += 1;

	return status;
}


template<>
bool test<const wchar_t*>(const char * test_msg, const wchar_t * provided, const wchar_t * expected)
{
	std::cout << "test " << test_counter << ": ";

	if( test_msg )
		std::cout << test_msg;

	bool status = (std::wcscmp(provided, expected) == 0);
	test_status(status);
	test_counter += 1;

	return status;
}


}


